'\" t
.\" black-hole-mta - email goes in but nothing comes out
.\" Copyright (C) 2007, 2009, 2011 Peter Miller
.\"
.\"     This program is free software; you can redistribute it and/or
.\"     modify it under the terms of the GNU General Public License as
.\"     published by the Free Software Foundation; either version 3 of
.\"     the License, or (at your option) any later version.
.\"
.\"     This program is distributed in the hope that it will be useful,
.\"     but WITHOUT ANY WARRANTY; without even the implied warranty of
.\"     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
.\"     GNU General Public License for more details.
.\"
.\"     You should have received a copy of the GNU General Public License
.\"     along with this program. If not, see
.\"     <http://www.gnu.org/licenses/>.
.\"
.TH Build black-hole-mta black-hole-mta "Reference Manual"
.so version.so
.if n .hy 0
.if n .ad l
.if n .nr IN 8n
.SH NAME
How to build black-hole-mta
.XX "" "How to build black-hole-mta"
.SH SPACE REQUIREMENTS
You will need about 3MB to unpack and build the Black Hole MTA package.
Your milage may vary.
.br
.ne 1i
.SH BEFORE YOU START
There are a few pieces of software you may want to fetch and install
before you proceed with your installation of black-hole-mta
.TP 8n
Boost
The Boost C++ libraries have been used to supplement the C++ STL.
See \f[CW]http://boost.org/\fP for downloads.
.TP 8n
GNU Groff
The documentation for the Black Hole MTA package was prepared using the
GNU Groff package (version 1.14 or later).  This distribution includes
full documentation, which may be processed into PostScript or DVI files
at install time \- if GNU Groff has been installed.
.TP 8n
GCC
You may also want to consider fetching and installing the GNU C Compiler
if you have not done so already.  This is not essential.  Black Hole MTA
was developed using the GNU C++ compiler, and the GNU C++ libraries.
.PP
The GNU FTP archives may be found at \f(CWftp.gnu.org\fP,
and are mirrored around the world.
.br
.ne 1i
.SH SITE CONFIGURATION
The Black Hole MTA package is configured using the \f[I]configure\fP
program included in this distribution.
.PP
The \f[I]configure\fP shell script attempts to guess correct values for
various system-dependent variables used during compilation, and creates
the \f[I]Makefile\fP and \f[I]lib/config.h\fP files.  It also creates
a shell script \f[I]config.status\fP that you can run in the future to
recreate the current configuration.
.PP
Normally, you just \f[I]cd\fP to the directory containing
\f[I]black-hole-mta\fP's source code and then type
.RS
.ft CW
.nf
\fB% \fP./configure
\fI\&...lots of output...\fP
\fB%\fP
.fi
.ft R
.RE
If you're using
.I csh
on an old version of System V,
you might need to type
.RS
.ft CW
.nf
\fB% \fPsh configure
\fI\&...lots of output...\fP
\fB%\fP
.fi
.ft R
.RE
instead to prevent \f[I]csh\fP from trying to execute \f[I]configure\fP
itself.
.PP
Running \f[I]configure\fP takes a minute or two.  While it is running,
it prints some messages that tell what it is doing.  If you don't want
to see the messages, run \f[I]configure\fP using the quiet option; for
example,
.RS
.FT CW
.nf
\fB% \fP./configure --quiet
\bB%\fP
.fi
.ft R
.RE
.PP
To compile the \f[B]black-hole-mta\fP package in a different directory
from the one containing the source code, you must use a version of
\f[I]make\fP that supports the \f[I]VPATH\fP variable, such as \f[I]GNU
make\fP.  Then \f[I]cd\fP to the directory where you want the object
files and executables to go and run the \f[I]configure\fP script.  The
\f[I]configure\fP script automatically checks for the source code in
the directory that \f[I]configure\fP is in and in \f[CW]\&..\fP (the
parent directory).  If for some reason \f[I]configure\fP is not in the
source code directory that you are configuring, then it will report that
it can't find the source code.  In that case, run \f[I]configure\fP
with the option \f(CW--srcdir=\fP\fIDIR\fP, where \f[I]DIR\fP is the
directory that contains the source code.
.PP
By default, \f[I]configure\fP will arrange for the \f[I]make install\fP
command to install the \f[B]black-hole-mta\fP package's files in
\f[I]/usr/local/bin\fP, and \f[I]/usr/local/man\fP.  There are options
which allow you to control the placement of these files.
.TP 8n
\f[CW]--prefix=\fP\fIPATH\fP
This specifies the path prefix to be used in the installation.
Defaults to \fI/usr/local\fP unless otherwise specified.
.TP 8n
\f[CW]--exec-prefix=\fP\fIPATH\fP
You can specify separate installation prefixes for
architecture-specific files files.
Defaults to \fI${prefix}\fP unless otherwise specified.
.TP 8n
\f[CW]--bindir=\fP\fIPATH\fP
This directory contains executable programs.  On a network, this
directory may be shared between machines with identical hardware and
operating systems; it may be mounted read-only.  Defaults to
\fI${exec_prefix}/bin\fP unless otherwise specified.
.TP 8n
\f[CW]--mandir=\fP\fIPATH\fP
This directory contains the on-line manual entries.  On a network, this
directory may be shared between all machines; it may be mounted
read-only.  Defaults to \fI${prefix}/man\fP unless otherwise specified.
.PP
The \f[I]configure\fP script ignores most other arguments that you give
it; use the \f[CW]--help\fP option for a complete list.
.br
.ne 2i
.PP
On systems that require unusual options for compilation or linking
that the
.I black-hole-mta
package's
\f[I]configure\fP
script does not know about,
you can give
\f[I]configure\fP
initial values for variables by setting them in the environment.
In Bourne-compatible shells,
you can do that on the command line like this:
.RS
.ft CW
.nf
\fB$ \fPCXX='g++ -traditional' LIBS=-lposix ./configure
\fI\&...lots of output...\fP
\fB$\fP
.fi
.ft R
.RE
Here are the
\f[I]make\fP
variables that you might want to override with
environment variables when running
\f[I]configure\fP.
.TP 8n
Variable: CXX
C++ compiler program.
The default is
\f[I]c++\fP.
.TP 8n
Variable: CPPFLAGS
Preprocessor flags, commonly defines and include search paths.
Defaults to empty.
It is common to use \f[CW]CPPFLAGS=-I/usr/local/include\fP to access other
installed packages.
.TP 8n
Variable: INSTALL
Program to use to install files.
The default is
\f[I]install\fP
if you have it,
\f[I]cp\fP
otherwise.
.TP 8n
Variable: LIBS
Libraries to link with,
in the form \f(CW-l\fP\fIfoo\fP \f(CW-l\fP\fIbar\fP.
The
\f[I]configure\fP
script will append to this,
rather than replace it.
It is common to use \f[CW]LIBS=-L/usr/local/lib\fP to access other
installed packages.
.PP
If you need to do unusual things to compile the package,
the author encourages you to figure out how
\f[I]configure\fP
could check whether to do them,
and mail diffs or instructions to the author
so that they can be included in the next release.
.br
.ne 1i
.SH BUILDING black-hole-mta
All you should need to do is use the
.RS
.ft CW
.nf
\fB% \fPmake
\fI\&...lots of output...\fP
\fB%\fP
.fi
.ft R
.RE
command and wait.
When this finishes you should see a directory called
\f[I]bin\fP
containing three files:
\f[I]black-hole-mta\fP,
\f[I]black-hole-mta\fP
and
\f[I]black-hole-mta\fP.
.TP 8n
.B black-hole-mta
.The
\f[I]black-hole-mta\fP
program is used to manipulate and convert EPROM load files.
For more information, see
\f[I]black-hole-mta\fP(1).
.TP 8n
.B black-hole-mta
The
\f[I]black-hole-mta\fP
program is used to compare EPROM load files.
For more information, see
\f[I]black-hole-mta\fP(1).
.TP 8n
.B black-hole-mta
The
\f[I]black-hole-mta\fP
program is used to print information about EPROM load files.
For more information, see
\f[I]black-hole-mta\fP(1).
.br
.ne 1.5i
.PP
If you have GNU Groff installed, the build will also create a
\f[I]etc/reference.ps\fP
file.  This contains the README file, this BUILDING file,
and all of the man pages.
.PP
You can remove the program binaries and object files from the
source directory by using the
.RS
.ft CW
.nf
\fB% \fPmake clean
\fI\&...lots of output...\fP
\fB%\fP
.fi
.ft R
.RE
command.
To remove all of the above files, and also remove the
\f[I]Makefile\fP
and
\f[I]lib/config.h\fP
and
\f[I]config.status\fP
files, use the
.RS
.ft CW
.nf
\fB% \fPmake distclean
\fI\&...lots of output...\fP
\fB%\fP
.fi
.ft R
.RE
command.
.PP
The file
\f[I]etc/configure.in\fP
is used to create
\f[I]configure\fP
by a GNU program called
\f[I]autoconf\fP.
You only need to know this if you want to regenerate
\f[I]configure\fP
using a newer version of
.IR autoconf .
.br
.ne 1i
.SH TESTING black-hole-mta
The
.I black-hole-mta
package comes with a test suite.
To run this test suite, use the command
.RS
.ft CW
.nf
\fB% \fPmake sure
\fI\&...lots of output...\fP
.if n \fBPassed All Tests\fP
.if t \f(CBPassed All Tests\fP
\fB%\fP
.fi
.ft R
.RE
.PP
The tests take a few seconds each,
with a few very fast,
and a couple very slow,
but it varies greatly depending on your CPU.
.PP
If all went well, the message
.RS
.ft CW
Passed All Tests
.ft R
.RE
should appear at the end of the make.
.br
.ne 1i
.SH INSTALLING black-hole-mta
As explained in the
.I "SITE CONFIGURATION"
section, above,
the
.I black-hole-mta
package is installed under the
.I /usr/local
tree by default.
Use the \f(CW--prefix=\fP\fIPATH\fP option to
.I configure
if you want some other path.
More specific installation locations are assignable,
use the \f(CW--help\fP option to
.I configure
for details.
.PP
All that is required to install the
.I black-hole-mta
package is to use the
.RS
.ft CW
.nf
\fB% \fPmake install
\fI\&...lots of output...\fP
\fB%\fP
.fi
.ft R
.RE
command.
Control of the directories used may be found in the first
few lines of the
.I Makefile
file and the other files written by the
.I configure
script;
it is best to reconfigure using the
.I configure
script, rather than attempting to do this by hand.
.br
.ne 1i
.SH GETTING HELP
If you need assistance with the
.I black-hole-mta
package,
please do not hesitate to contact the author at
.RS
.ft CW
Peter Miller <pmiller@opensource.org.au>
.ft R
.RE
Any and all feedback is welcome.
.PP
When reporting problems,
please include the version number
given by the
.RS
.ft CW
.nf
\fB% \fPblack-hole-mta -version
.if n \fBblack-hole-mta version\fP \fI\*(V)\fP
.if t \f(CBblack-hole-mta version\fP \fI\*(V)\fP
\fI\&...warranty disclaimer...\fP
\fB%\fP
.fi
.ft R
.RE
command.
Please do not send this example;
run the program for the exact version number.
.br
.ne 2i
.SH COPYRIGHT
.I black-hole-mta
version \*(v)
.br
Copyright
.if n (C)
.if t \(co
\*(Y) Peter Miller
.PP
The
.I black-hole-mta
package is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.
.PP
It should be in the
.I LICENSE
file included with this distribution.
.br
.ne 1i
.SH AUTHOR
.TS
tab(;);
l r l.
Peter Miller;E-Mail:;pmiller@opensource.org.au
\f(CW/\e/\e*\fP;WWW:;http://miller.emu.id.au/pmiller/
.TE
.\" vim: set ts=8 sw=4 et :
