//
//      black-hole-mta - email goes in but nothing comes out
//      Copyright (C) 2007, 2011 Peter Miller
//
//      This program is free software; you can redistribute it and/or
//      modify it under the terms of the GNU General Public License as
//      published by the Free Software Foundation; either version 3 of
//      the License, or (at your option) any later version.
//
//      This program is distributed in the hope that it will be useful,
//      but WITHOUT ANY WARRANTY; without even the implied warranty of
//      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//      GNU General Public License for more details.
//
//      You should have received a copy of the GNU General Public License
//      along with this program. If not, see
//      <http://www.gnu.org/licenses/>.
//

#include <cstdio>

#include <lib/mail_transfer_agent/black_hole.h>


mail_transfer_agent_black_hole::~mail_transfer_agent_black_hole()
{
}


mail_transfer_agent_black_hole::mail_transfer_agent_black_hole()
{
}


void
mail_transfer_agent_black_hole::mailq()
{
    printf("Mail queue is empty\n");
}


void
mail_transfer_agent_black_hole::newaliases()
{
    // Do nothing.
}


void
mail_transfer_agent_black_hole::send(const std::string &, const std::string &)
{
    // Do nothing.
}


void
mail_transfer_agent_black_hole::verify(const string_list_t &)
{
    // Do nothing.
}


void
mail_transfer_agent_black_hole::purge_host_status()
{
    // Do nothing.
}


void
mail_transfer_agent_black_hole::print_host_status()
{
    // Do nothing.
}


// vim: set ts=8 sw=4 et :
