//
//      black-hole-mta - email goes in but nothing comes out
//      Copyright (C) 2007, 2009, 2011, 2012 Peter Miller
//
//      This program is free software; you can redistribute it and/or
//      modify it under the terms of the GNU General Public License as
//      published by the Free Software Foundation; either version 3 of
//      the License, or (at your option) any later version.
//
//      This program is distributed in the hope that it will be useful,
//      but WITHOUT ANY WARRANTY; without even the implied warranty of
//      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//      GNU General Public License for more details.
//
//      You should have received a copy of the GNU General Public License
//      along with this program. If not, see
//      <http://www.gnu.org/licenses/>.
//

#include <lib/config.h>
#include <cstdio>
#include <libexplain/program_name.h>

#include <lib/mail_transfer_agent.h>


void
mail_transfer_agent::newaliases(int argc, char **argv)
{
    explain_program_name_set(argv[0]);
    for (;;)
    {
        int c = getopt(argc, argv, "C:O:o:");
        if (c == EOF)
            break;
        switch (c)
        {
        case 'C':
            set_configuration_file(optarg);
            break;

        case 'o':
        case 'O':
            parse_and_set(optarg);
            break;

        default:
            usage_without_names();
            // NOTREACHED
        }
    }
    if (optind != argc)
        usage_without_names();
    newaliases();
}


void
mail_transfer_agent::newaliases_glue(const string_list_t &names)
{
    if (!names.empty())
        no_names_on_command_line();
    newaliases();
}


// vim: set ts=8 sw=4 et :
